<template>
  <div class="todos-app" :class="name">

    <gside name="left todos-categories">
      <span class="icon icon-button" slot="toggle">
        <i class="fa fa-bars" aria-hidden="true"></i>
      </span>
      <div slot="content" class="w-paddedx2">
        <figure class="image is-48x48 w-marginless">
          <img class ="w-circle" src="https://bulma.io/images/placeholders/128x128.png">
        </figure>
        <p class="w-marginless">J Hernandez</p>
        <p class="is-size-7">jayroht_93@hotmail.com</p>
        <div class="categories-wrapper w-scrollbar" style="height:18.5rem; margin-bottom:.5rem">
          <div class="field" v-for="(item, i) in categories" :key="i">
             <input class="is-checkradio" :id="item.name" type="radio" name="categories" :checked="item.active" @change="categorySelected({'input':'categories','value':item.name})">
             <label :for="item.name">{{item.description}}</label>
          </div>
        </div>
        <div class="field">
          <div class="control">
            <input class="input is-primary"
                   type="text"
                   v-model="emptyCategory.description"
                   @keyup.enter="addCategory()"
                   placeholder="New category">>
          </div>
        </div>
      </div>
    </gside>
    <!-- <div class="field todo-filters">
      <div class="control  has-icons-left">
        <div class="select is-small" v-if="categories">
          <bselect @input-change="categorySelected($event)" :options="categories" name="categories"></bselect>
        </div>
        <div class="icon is-small is-left">
          <i class="basicfill basicfill-funnel"></i>
        </div>
      </div>
    </div> -->

    <div class="field todo-new">
      <input class="input is-primary"
      type="text"
      autofocus
      v-model="newTodo"
      @keyup.enter="addTodo($event)"
      placeholder="New todo">
    </div>

    <div class="todos w-scrollbar">
      <div class="field is-grouped todo-item" v-for="(todo , $i) in $filterTodos" :key="$i">
      <div class="control field">
          <input type="checkbox" :id="$i" class="is-checkradio  has-background-color is-success is-circle" :checked="todo.completed" v-model="todo.completed">
          <label :for="$i" class="checkbox-label"></label>
      </div>
       <div class="control is-expanded">
          <label @dblclick="editTodo(todo)" :class="{completed: todo.completed}" v-show="!editedTodo || editedTodo.id != todo.id">{{todo.title}}</label>
          <input class="input is-small"
          type="text"
          v-show="editedTodo && editedTodo.id == todo.id"
          v-model="todo.title"
          v-todo-focus="todo == editedTodo"
          @blur="doneEdit(todo)"
          @keyup.enter="doneEdit(todo)"
          @keyup.esc="cancelEdit(todo)">
      </div>
      <div class="control">
        <a class="delete" @click="removeTodo(todo)"></a>
      </div>
    </div>

    </div>
    <div class="field is-grouped todo-visibility">
      <a class="button is-rounded is-small" @click="setVisibility('all')" :class="{'is-primary' : visibility === 'all'}">All</a>
      <a class="button is-rounded is-small" @click="setVisibility('active')" :class="{'is-primary' : visibility === 'active'}">Active</a>
      <a class="button is-rounded is-small" @click="setVisibility('completed')" :class="{'is-primary' : visibility === 'completed'}">Completed</a>
   </div>
  </div>
</template>

<script>
import Bselect from "./../../bulma/Bselect";
import Gside from "./../../Gside";

import { storage } from "./../../../utilities/storage_model.js";
import { filters } from "./../../../utilities/todo_utilities.js";

import { category } from "./../../../utilities/todo_utilities.js";

var todosKey = "todos_storage";
var todosCategoryKey = "todos_category_key";

export default {
  name: "todosApp",
  components: {
    Bselect,
    Gside
  },
  props: {
    name: {
      type: String,
      default: ""
    }
  },
  data() {
    return {
      todosKey: todosKey,
      todosCategoryKey: todosCategoryKey,
      todos: storage.fetch(todosKey),
      categories: storage.fetch(todosCategoryKey),
      newTodo: "",
      editedTodo: null,
      visibility: "all",
      emptyCategory: {
        description: ""
      }
    };
  },
  methods: {
    addTodo: function(event) {
      let todo = event.target.value;
      let id = Math.floor(event.timeStamp);
      if (todo) {
        let d = new Date();
        let createDate = `${d.getDate()}/${d.getMonth()}/${d.getFullYear()}`;
        let createTime = `${d.getHours()}:${d.getMinutes()}`;
        let category = this.$category;
        this.todos.push({
          id: id,
          title: todo,
          completed: false,
          date: "30/11/2017", //TODO- CALENDAR
          time: "18:00", //TODO- CALENDAR
          category: category.name || "",
          note: "",
          tags: [],
          createDate: createDate,
          createTime: createTime
        });
        this.newTodo = "";
      }
    },
    editTodo: function(todo) {
      this.beforeEditCache = todo.title;
      this.editedTodo = todo;
    },
    doneEdit: function(todo) {
      if (!this.editedTodo) {
        return;
      }
      this.editedTodo = null;
      todo.title = todo.title.trim();
      if (!todo.title) {
        this.removeTodo(todo);
      }
    },
    cancelEdit: function(todo) {
      this.editedTodo = null;
      todo.title = this.beforeEditCache;
    },
    removeTodo: function(todo) {
      this.todos.splice(this.todos.indexOf(todo), 1);
    },
    setVisibility: function(visibility) {
      this.visibility = visibility;
    },
    categorySelected: function(input) {
      let i;
      let categories = this.categories;
      for (i in categories) {
        categories[i].active =
          categories[i].name === input.value ? true : false;
      }
    },
    addCategory: function() {
      let options = this.emptyCategory;
      let newCategory = new category(options);
      this.categories.push(newCategory);
    }
  },
  computed: {
    $filterTodos: function() {
      let todos = filters[this.visibility](this.todos);
      let category = this.$category;
      return todos.filter(todo => {
        if (category && category.name) {
          return todo.category === category.name;
        } else {
          return true;
        }
      });
    },
    $category: function() {
      let categories = this.categories;
      let current = categories.filter(item => {
        return item.active === true;
      });
      return current[0] || "";
    }
  },
  watch: {
    todos: {
      handler: function(todos) {
        storage.save(this.todosKey, todos);
      },
      deep: true
    },
    categories: {
      handler: function(categories) {
        storage.save(this.todosCategoryKey, categories);
      },
      deep: true
    }
  },
  // a custom directive to wait for the DOM to be updated
  // before focusing on the input field.
  // http://vuejs.org/guide/custom-directive.html
  directives: {
    "todo-focus": function(el, binding) {
      if (binding.value) {
        el.focus();
      }
    }
  }
};
</script>

<style scoped lang="scss">
.todos-app {
  width: 22rem;
  padding: 0.7rem;
  padding-right: 0;
  padding-bottom: 3rem;
  position: relative;
  overflow: hidden;
  .todos {
    height: 22rem;
    padding-right: 0.7rem;
    .todo-item {
      .checkbox-label {
        padding-left: 0rem;
      }
      .completed {
        text-decoration: line-through;
      }
    }
  }
  .todo-visibility {
    padding-top: 0.5rem;
    position: absolute;
    bottom: 0.5rem;
    .is-rounded {
      margin-right: 0.3rem;
    }
  }
}
</style>
